/* DiskManager.c generated by valac 0.45.3, the Vala compiler
 * generated from DiskManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013-2014 Audience Developers (http://launchpad.net/pantheon-chat)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>

#define AUDIENCE_TYPE_DISK_MANAGER (audience_disk_manager_get_type ())
#define AUDIENCE_DISK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AUDIENCE_TYPE_DISK_MANAGER, AudienceDiskManager))
#define AUDIENCE_DISK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AUDIENCE_TYPE_DISK_MANAGER, AudienceDiskManagerClass))
#define AUDIENCE_IS_DISK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AUDIENCE_TYPE_DISK_MANAGER))
#define AUDIENCE_IS_DISK_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AUDIENCE_TYPE_DISK_MANAGER))
#define AUDIENCE_DISK_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AUDIENCE_TYPE_DISK_MANAGER, AudienceDiskManagerClass))

typedef struct _AudienceDiskManager AudienceDiskManager;
typedef struct _AudienceDiskManagerClass AudienceDiskManagerClass;
typedef struct _AudienceDiskManagerPrivate AudienceDiskManagerPrivate;
enum  {
	AUDIENCE_DISK_MANAGER_0_PROPERTY,
	AUDIENCE_DISK_MANAGER_NUM_PROPERTIES
};
static GParamSpec* audience_disk_manager_properties[AUDIENCE_DISK_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	AUDIENCE_DISK_MANAGER_VOLUME_FOUND_SIGNAL,
	AUDIENCE_DISK_MANAGER_VOLUME_REMOVED_SIGNAL,
	AUDIENCE_DISK_MANAGER_NUM_SIGNALS
};
static guint audience_disk_manager_signals[AUDIENCE_DISK_MANAGER_NUM_SIGNALS] = {0};

struct _AudienceDiskManager {
	GObject parent_instance;
	AudienceDiskManagerPrivate * priv;
};

struct _AudienceDiskManagerClass {
	GObjectClass parent_class;
};

struct _AudienceDiskManagerPrivate {
	GVolumeMonitor* monitor;
	GeeTreeSet* volumes;
};

static gint AudienceDiskManager_private_offset;
static gpointer audience_disk_manager_parent_class = NULL;
static AudienceDiskManager* audience_disk_manager_disk_manager;
static AudienceDiskManager* audience_disk_manager_disk_manager = NULL;

GType audience_disk_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AudienceDiskManager, g_object_unref)
AudienceDiskManager* audience_disk_manager_get_default (void);
static AudienceDiskManager* audience_disk_manager_new (void);
static AudienceDiskManager* audience_disk_manager_construct (GType object_type);
GeeTreeSet* audience_disk_manager_get_volumes (AudienceDiskManager* self);
GeeTreeSet* audience_disk_manager_get_media_volumes (AudienceDiskManager* self);
static gboolean audience_disk_manager_has_dvd_media (AudienceDiskManager* self,
                                              GVolume* volume);
gboolean audience_disk_manager_has_media_volumes (AudienceDiskManager* self);
static void audience_disk_manager_check_for_volume (AudienceDiskManager* self,
                                             GVolume* volume);
static GObject * audience_disk_manager_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static void _audience_disk_manager___lambda28_ (AudienceDiskManager* self,
                                         GVolume* volume);
static void __audience_disk_manager___lambda28__gfunc (gconstpointer data,
                                                gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _audience_disk_manager___lambda29_ (AudienceDiskManager* self,
                                         GDrive* drive);
static void __audience_disk_manager___lambda29__g_volume_monitor_drive_changed (GVolumeMonitor* _sender,
                                                                         GDrive* drive,
                                                                         gpointer self);
static void _audience_disk_manager___lambda30_ (AudienceDiskManager* self,
                                         GDrive* drive);
static void __audience_disk_manager___lambda30__g_volume_monitor_drive_connected (GVolumeMonitor* _sender,
                                                                           GDrive* drive,
                                                                           gpointer self);
static void _audience_disk_manager___lambda31_ (AudienceDiskManager* self,
                                         GDrive* drive);
static void __audience_disk_manager___lambda31__g_volume_monitor_drive_disconnected (GVolumeMonitor* _sender,
                                                                              GDrive* drive,
                                                                              gpointer self);
static void _audience_disk_manager___lambda32_ (AudienceDiskManager* self,
                                         GDrive* drive);
static void __audience_disk_manager___lambda32__g_volume_monitor_drive_eject_button (GVolumeMonitor* _sender,
                                                                              GDrive* drive,
                                                                              gpointer self);
static void _audience_disk_manager___lambda33_ (AudienceDiskManager* self,
                                         GDrive* drive);
static void __audience_disk_manager___lambda33__g_volume_monitor_drive_stop_button (GVolumeMonitor* _sender,
                                                                             GDrive* drive,
                                                                             gpointer self);
static void _audience_disk_manager___lambda34_ (AudienceDiskManager* self,
                                         GVolume* volume);
static void __audience_disk_manager___lambda34__g_volume_monitor_volume_added (GVolumeMonitor* _sender,
                                                                        GVolume* volume,
                                                                        gpointer self);
static void _audience_disk_manager___lambda35_ (AudienceDiskManager* self,
                                         GVolume* volume);
static void __audience_disk_manager___lambda35__g_volume_monitor_volume_changed (GVolumeMonitor* _sender,
                                                                          GVolume* volume,
                                                                          gpointer self);
static void _audience_disk_manager___lambda36_ (AudienceDiskManager* self,
                                         GVolume* volume);
static void __audience_disk_manager___lambda36__g_volume_monitor_volume_removed (GVolumeMonitor* _sender,
                                                                          GVolume* volume,
                                                                          gpointer self);
static void audience_disk_manager_finalize (GObject * obj);

static inline gpointer
audience_disk_manager_get_instance_private (AudienceDiskManager* self)
{
	return G_STRUCT_MEMBER_P (self, AudienceDiskManager_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 31 "../src/DiskManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 149 "DiskManager.c"
}

AudienceDiskManager*
audience_disk_manager_get_default (void)
{
	AudienceDiskManager* result = NULL;
	AudienceDiskManager* _tmp0_;
	AudienceDiskManager* _tmp2_;
	AudienceDiskManager* _tmp3_;
#line 27 "../src/DiskManager.vala"
	_tmp0_ = audience_disk_manager_disk_manager;
#line 27 "../src/DiskManager.vala"
	if (_tmp0_ == NULL) {
#line 163 "DiskManager.c"
		AudienceDiskManager* _tmp1_;
#line 28 "../src/DiskManager.vala"
		_tmp1_ = audience_disk_manager_new ();
#line 28 "../src/DiskManager.vala"
		_g_object_unref0 (audience_disk_manager_disk_manager);
#line 28 "../src/DiskManager.vala"
		audience_disk_manager_disk_manager = _tmp1_;
#line 171 "DiskManager.c"
	}
#line 31 "../src/DiskManager.vala"
	_tmp2_ = audience_disk_manager_disk_manager;
#line 31 "../src/DiskManager.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 31 "../src/DiskManager.vala"
	result = _tmp3_;
#line 31 "../src/DiskManager.vala"
	return result;
#line 181 "DiskManager.c"
}

static AudienceDiskManager*
audience_disk_manager_construct (GType object_type)
{
	AudienceDiskManager * self = NULL;
#line 37 "../src/DiskManager.vala"
	self = (AudienceDiskManager*) g_object_new (object_type, NULL);
#line 37 "../src/DiskManager.vala"
	return self;
#line 192 "DiskManager.c"
}

static AudienceDiskManager*
audience_disk_manager_new (void)
{
#line 37 "../src/DiskManager.vala"
	return audience_disk_manager_construct (AUDIENCE_TYPE_DISK_MANAGER);
#line 200 "DiskManager.c"
}

GeeTreeSet*
audience_disk_manager_get_volumes (AudienceDiskManager* self)
{
	GeeTreeSet* result = NULL;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
#line 85 "../src/DiskManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 86 "../src/DiskManager.vala"
	_tmp0_ = self->priv->volumes;
#line 86 "../src/DiskManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 86 "../src/DiskManager.vala"
	result = _tmp1_;
#line 86 "../src/DiskManager.vala"
	return result;
#line 219 "DiskManager.c"
}

GeeTreeSet*
audience_disk_manager_get_media_volumes (AudienceDiskManager* self)
{
	GeeTreeSet* result = NULL;
	GeeTreeSet* return_value = NULL;
	GeeTreeSet* _tmp0_;
#line 89 "../src/DiskManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 90 "../src/DiskManager.vala"
	_tmp0_ = gee_tree_set_new (g_volume_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 90 "../src/DiskManager.vala"
	return_value = _tmp0_;
#line 234 "DiskManager.c"
	{
		GeeIterator* _volume_it = NULL;
		GeeTreeSet* _tmp1_;
		GeeIterator* _tmp2_;
#line 91 "../src/DiskManager.vala"
		_tmp1_ = self->priv->volumes;
#line 91 "../src/DiskManager.vala"
		_tmp2_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp1_);
#line 91 "../src/DiskManager.vala"
		_volume_it = _tmp2_;
#line 91 "../src/DiskManager.vala"
		while (TRUE) {
#line 247 "DiskManager.c"
			GeeIterator* _tmp3_;
			GVolume* volume = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			GVolume* _tmp6_;
#line 91 "../src/DiskManager.vala"
			_tmp3_ = _volume_it;
#line 91 "../src/DiskManager.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 91 "../src/DiskManager.vala"
				break;
#line 259 "DiskManager.c"
			}
#line 91 "../src/DiskManager.vala"
			_tmp4_ = _volume_it;
#line 91 "../src/DiskManager.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 91 "../src/DiskManager.vala"
			volume = (GVolume*) _tmp5_;
#line 92 "../src/DiskManager.vala"
			_tmp6_ = volume;
#line 92 "../src/DiskManager.vala"
			if (audience_disk_manager_has_dvd_media (self, _tmp6_)) {
#line 271 "DiskManager.c"
				GeeTreeSet* _tmp7_;
				GVolume* _tmp8_;
#line 93 "../src/DiskManager.vala"
				_tmp7_ = return_value;
#line 93 "../src/DiskManager.vala"
				_tmp8_ = volume;
#line 93 "../src/DiskManager.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp8_);
#line 280 "DiskManager.c"
			}
#line 91 "../src/DiskManager.vala"
			_g_object_unref0 (volume);
#line 284 "DiskManager.c"
		}
#line 91 "../src/DiskManager.vala"
		_g_object_unref0 (_volume_it);
#line 288 "DiskManager.c"
	}
#line 97 "../src/DiskManager.vala"
	result = return_value;
#line 97 "../src/DiskManager.vala"
	return result;
#line 294 "DiskManager.c"
}

gboolean
audience_disk_manager_has_media_volumes (AudienceDiskManager* self)
{
	gboolean result = FALSE;
	GeeTreeSet* _tmp0_;
	GeeTreeSet* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
#line 100 "../src/DiskManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 101 "../src/DiskManager.vala"
	_tmp0_ = audience_disk_manager_get_media_volumes (self);
#line 101 "../src/DiskManager.vala"
	_tmp1_ = _tmp0_;
#line 101 "../src/DiskManager.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 101 "../src/DiskManager.vala"
	_tmp3_ = _tmp2_;
#line 101 "../src/DiskManager.vala"
	_tmp4_ = _tmp3_ > 0;
#line 101 "../src/DiskManager.vala"
	_g_object_unref0 (_tmp1_);
#line 101 "../src/DiskManager.vala"
	result = _tmp4_;
#line 101 "../src/DiskManager.vala"
	return result;
#line 324 "DiskManager.c"
}

static void
audience_disk_manager_check_for_volume (AudienceDiskManager* self,
                                        GVolume* volume)
{
#line 104 "../src/DiskManager.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/DiskManager.vala"
	g_return_if_fail (volume != NULL);
#line 105 "../src/DiskManager.vala"
	if (audience_disk_manager_has_dvd_media (self, volume)) {
#line 337 "DiskManager.c"
		GeeTreeSet* _tmp0_;
#line 106 "../src/DiskManager.vala"
		_tmp0_ = self->priv->volumes;
#line 106 "../src/DiskManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, volume);
#line 107 "../src/DiskManager.vala"
		g_signal_emit (self, audience_disk_manager_signals[AUDIENCE_DISK_MANAGER_VOLUME_FOUND_SIGNAL], 0, volume);
#line 345 "DiskManager.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 365 "DiskManager.c"
}

static gboolean
audience_disk_manager_has_dvd_media (AudienceDiskManager* self,
                                     GVolume* volume)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* icon_name = NULL;
	GIcon* _tmp2_;
	GIcon* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gboolean _tmp7_ = FALSE;
	GDrive* _tmp8_;
	GDrive* _tmp9_;
	gboolean _tmp10_;
#line 111 "../src/DiskManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 111 "../src/DiskManager.vala"
	g_return_val_if_fail (volume != NULL, FALSE);
#line 112 "../src/DiskManager.vala"
	_tmp0_ = g_volume_get_name (volume);
#line 112 "../src/DiskManager.vala"
	_tmp1_ = _tmp0_;
#line 112 "../src/DiskManager.vala"
	g_debug ("DiskManager.vala:112: Check DVD media for: %s", _tmp1_);
#line 112 "../src/DiskManager.vala"
	_g_free0 (_tmp1_);
#line 115 "../src/DiskManager.vala"
	_tmp2_ = g_volume_get_icon (volume);
#line 115 "../src/DiskManager.vala"
	_tmp3_ = _tmp2_;
#line 115 "../src/DiskManager.vala"
	_tmp4_ = g_icon_to_string (_tmp3_);
#line 115 "../src/DiskManager.vala"
	_tmp5_ = _tmp4_;
#line 115 "../src/DiskManager.vala"
	_g_object_unref0 (_tmp3_);
#line 115 "../src/DiskManager.vala"
	icon_name = _tmp5_;
#line 116 "../src/DiskManager.vala"
	_tmp6_ = icon_name;
#line 116 "../src/DiskManager.vala"
	if (!string_contains (_tmp6_, "optical")) {
#line 117 "../src/DiskManager.vala"
		result = FALSE;
#line 117 "../src/DiskManager.vala"
		_g_free0 (icon_name);
#line 117 "../src/DiskManager.vala"
		return result;
#line 419 "DiskManager.c"
	}
#line 119 "../src/DiskManager.vala"
	_tmp8_ = g_volume_get_drive (volume);
#line 119 "../src/DiskManager.vala"
	_tmp9_ = _tmp8_;
#line 119 "../src/DiskManager.vala"
	_tmp10_ = _tmp9_ != NULL;
#line 119 "../src/DiskManager.vala"
	_g_object_unref0 (_tmp9_);
#line 119 "../src/DiskManager.vala"
	if (_tmp10_) {
#line 431 "DiskManager.c"
		GDrive* _tmp11_;
		GDrive* _tmp12_;
#line 119 "../src/DiskManager.vala"
		_tmp11_ = g_volume_get_drive (volume);
#line 119 "../src/DiskManager.vala"
		_tmp12_ = _tmp11_;
#line 119 "../src/DiskManager.vala"
		_tmp7_ = g_drive_has_media (_tmp12_);
#line 119 "../src/DiskManager.vala"
		_g_object_unref0 (_tmp12_);
#line 442 "DiskManager.c"
	} else {
#line 119 "../src/DiskManager.vala"
		_tmp7_ = FALSE;
#line 446 "DiskManager.c"
	}
#line 119 "../src/DiskManager.vala"
	if (_tmp7_) {
#line 450 "DiskManager.c"
		GFile* root = NULL;
		GMount* _tmp13_;
		GMount* _tmp14_;
		GFile* _tmp15_;
		GFile* _tmp16_;
		GFile* _tmp17_;
#line 120 "../src/DiskManager.vala"
		_tmp13_ = g_volume_get_mount (volume);
#line 120 "../src/DiskManager.vala"
		_tmp14_ = _tmp13_;
#line 120 "../src/DiskManager.vala"
		_tmp15_ = g_mount_get_default_location (_tmp14_);
#line 120 "../src/DiskManager.vala"
		_tmp16_ = _tmp15_;
#line 120 "../src/DiskManager.vala"
		_g_object_unref0 (_tmp14_);
#line 120 "../src/DiskManager.vala"
		root = _tmp16_;
#line 121 "../src/DiskManager.vala"
		_tmp17_ = root;
#line 121 "../src/DiskManager.vala"
		if (_tmp17_ != NULL) {
#line 473 "DiskManager.c"
			GFile* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			GFile* video = NULL;
			GFile* _tmp21_;
			GFile* _tmp22_;
			GFile* bdmv = NULL;
			GFile* _tmp23_;
			GFile* _tmp24_;
			gboolean _tmp25_ = FALSE;
			GFile* _tmp26_;
#line 122 "../src/DiskManager.vala"
			_tmp18_ = root;
#line 122 "../src/DiskManager.vala"
			_tmp19_ = g_file_get_uri (_tmp18_);
#line 122 "../src/DiskManager.vala"
			_tmp20_ = _tmp19_;
#line 122 "../src/DiskManager.vala"
			g_debug ("DiskManager.vala:122: Activation root: %s", _tmp20_);
#line 122 "../src/DiskManager.vala"
			_g_free0 (_tmp20_);
#line 123 "../src/DiskManager.vala"
			_tmp21_ = root;
#line 123 "../src/DiskManager.vala"
			_tmp22_ = g_file_get_child (_tmp21_, "VIDEO_TS");
#line 123 "../src/DiskManager.vala"
			video = _tmp22_;
#line 124 "../src/DiskManager.vala"
			_tmp23_ = root;
#line 124 "../src/DiskManager.vala"
			_tmp24_ = g_file_get_child (_tmp23_, "BDMV");
#line 124 "../src/DiskManager.vala"
			bdmv = _tmp24_;
#line 125 "../src/DiskManager.vala"
			_tmp26_ = video;
#line 125 "../src/DiskManager.vala"
			if (g_file_query_exists (_tmp26_, NULL)) {
#line 125 "../src/DiskManager.vala"
				_tmp25_ = TRUE;
#line 513 "DiskManager.c"
			} else {
				GFile* _tmp27_;
#line 125 "../src/DiskManager.vala"
				_tmp27_ = bdmv;
#line 125 "../src/DiskManager.vala"
				_tmp25_ = g_file_query_exists (_tmp27_, NULL);
#line 520 "DiskManager.c"
			}
#line 125 "../src/DiskManager.vala"
			if (_tmp25_) {
#line 126 "../src/DiskManager.vala"
				result = TRUE;
#line 126 "../src/DiskManager.vala"
				_g_object_unref0 (bdmv);
#line 126 "../src/DiskManager.vala"
				_g_object_unref0 (video);
#line 126 "../src/DiskManager.vala"
				_g_object_unref0 (root);
#line 126 "../src/DiskManager.vala"
				_g_free0 (icon_name);
#line 126 "../src/DiskManager.vala"
				return result;
#line 536 "DiskManager.c"
			}
#line 121 "../src/DiskManager.vala"
			_g_object_unref0 (bdmv);
#line 121 "../src/DiskManager.vala"
			_g_object_unref0 (video);
#line 542 "DiskManager.c"
		}
#line 119 "../src/DiskManager.vala"
		_g_object_unref0 (root);
#line 546 "DiskManager.c"
	}
#line 130 "../src/DiskManager.vala"
	result = FALSE;
#line 130 "../src/DiskManager.vala"
	_g_free0 (icon_name);
#line 130 "../src/DiskManager.vala"
	return result;
#line 554 "DiskManager.c"
}

static void
_audience_disk_manager___lambda28_ (AudienceDiskManager* self,
                                    GVolume* volume)
{
	GeeTreeSet* _tmp0_;
#line 44 "../src/DiskManager.vala"
	g_return_if_fail (volume != NULL);
#line 45 "../src/DiskManager.vala"
	_tmp0_ = self->priv->volumes;
#line 45 "../src/DiskManager.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, volume);
#line 568 "DiskManager.c"
}

static void
__audience_disk_manager___lambda28__gfunc (gconstpointer data,
                                           gpointer self)
{
#line 44 "../src/DiskManager.vala"
	_audience_disk_manager___lambda28_ ((AudienceDiskManager*) self, (GVolume*) data);
#line 577 "DiskManager.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 44 "../src/DiskManager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 585 "DiskManager.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 44 "../src/DiskManager.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 593 "DiskManager.c"
}

static void
_audience_disk_manager___lambda29_ (AudienceDiskManager* self,
                                    GDrive* drive)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 48 "../src/DiskManager.vala"
	g_return_if_fail (drive != NULL);
#line 49 "../src/DiskManager.vala"
	_tmp0_ = g_drive_get_name (drive);
#line 49 "../src/DiskManager.vala"
	_tmp1_ = _tmp0_;
#line 49 "../src/DiskManager.vala"
	g_debug ("DiskManager.vala:49: Drive changed: %s\n", _tmp1_);
#line 49 "../src/DiskManager.vala"
	_g_free0 (_tmp1_);
#line 612 "DiskManager.c"
}

static void
__audience_disk_manager___lambda29__g_volume_monitor_drive_changed (GVolumeMonitor* _sender,
                                                                    GDrive* drive,
                                                                    gpointer self)
{
#line 48 "../src/DiskManager.vala"
	_audience_disk_manager___lambda29_ ((AudienceDiskManager*) self, drive);
#line 622 "DiskManager.c"
}

static void
_audience_disk_manager___lambda30_ (AudienceDiskManager* self,
                                    GDrive* drive)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 52 "../src/DiskManager.vala"
	g_return_if_fail (drive != NULL);
#line 53 "../src/DiskManager.vala"
	_tmp0_ = g_drive_get_name (drive);
#line 53 "../src/DiskManager.vala"
	_tmp1_ = _tmp0_;
#line 53 "../src/DiskManager.vala"
	g_debug ("DiskManager.vala:53: Drive connected: %s", _tmp1_);
#line 53 "../src/DiskManager.vala"
	_g_free0 (_tmp1_);
#line 641 "DiskManager.c"
}

static void
__audience_disk_manager___lambda30__g_volume_monitor_drive_connected (GVolumeMonitor* _sender,
                                                                      GDrive* drive,
                                                                      gpointer self)
{
#line 52 "../src/DiskManager.vala"
	_audience_disk_manager___lambda30_ ((AudienceDiskManager*) self, drive);
#line 651 "DiskManager.c"
}

static void
_audience_disk_manager___lambda31_ (AudienceDiskManager* self,
                                    GDrive* drive)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 56 "../src/DiskManager.vala"
	g_return_if_fail (drive != NULL);
#line 57 "../src/DiskManager.vala"
	_tmp0_ = g_drive_get_name (drive);
#line 57 "../src/DiskManager.vala"
	_tmp1_ = _tmp0_;
#line 57 "../src/DiskManager.vala"
	g_debug ("DiskManager.vala:57: Drive disconnected: %s", _tmp1_);
#line 57 "../src/DiskManager.vala"
	_g_free0 (_tmp1_);
#line 670 "DiskManager.c"
}

static void
__audience_disk_manager___lambda31__g_volume_monitor_drive_disconnected (GVolumeMonitor* _sender,
                                                                         GDrive* drive,
                                                                         gpointer self)
{
#line 56 "../src/DiskManager.vala"
	_audience_disk_manager___lambda31_ ((AudienceDiskManager*) self, drive);
#line 680 "DiskManager.c"
}

static void
_audience_disk_manager___lambda32_ (AudienceDiskManager* self,
                                    GDrive* drive)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 60 "../src/DiskManager.vala"
	g_return_if_fail (drive != NULL);
#line 61 "../src/DiskManager.vala"
	_tmp0_ = g_drive_get_name (drive);
#line 61 "../src/DiskManager.vala"
	_tmp1_ = _tmp0_;
#line 61 "../src/DiskManager.vala"
	g_debug ("DiskManager.vala:61: Drive eject-button: %s", _tmp1_);
#line 61 "../src/DiskManager.vala"
	_g_free0 (_tmp1_);
#line 699 "DiskManager.c"
}

static void
__audience_disk_manager___lambda32__g_volume_monitor_drive_eject_button (GVolumeMonitor* _sender,
                                                                         GDrive* drive,
                                                                         gpointer self)
{
#line 60 "../src/DiskManager.vala"
	_audience_disk_manager___lambda32_ ((AudienceDiskManager*) self, drive);
#line 709 "DiskManager.c"
}

static void
_audience_disk_manager___lambda33_ (AudienceDiskManager* self,
                                    GDrive* drive)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 64 "../src/DiskManager.vala"
	g_return_if_fail (drive != NULL);
#line 65 "../src/DiskManager.vala"
	_tmp0_ = g_drive_get_name (drive);
#line 65 "../src/DiskManager.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/DiskManager.vala"
	g_debug ("DiskManager.vala:65: Drive stop-button:%s", _tmp1_);
#line 65 "../src/DiskManager.vala"
	_g_free0 (_tmp1_);
#line 728 "DiskManager.c"
}

static void
__audience_disk_manager___lambda33__g_volume_monitor_drive_stop_button (GVolumeMonitor* _sender,
                                                                        GDrive* drive,
                                                                        gpointer self)
{
#line 64 "../src/DiskManager.vala"
	_audience_disk_manager___lambda33_ ((AudienceDiskManager*) self, drive);
#line 738 "DiskManager.c"
}

static void
_audience_disk_manager___lambda34_ (AudienceDiskManager* self,
                                    GVolume* volume)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 68 "../src/DiskManager.vala"
	g_return_if_fail (volume != NULL);
#line 69 "../src/DiskManager.vala"
	audience_disk_manager_check_for_volume (self, volume);
#line 70 "../src/DiskManager.vala"
	_tmp0_ = g_volume_get_name (volume);
#line 70 "../src/DiskManager.vala"
	_tmp1_ = _tmp0_;
#line 70 "../src/DiskManager.vala"
	g_debug ("DiskManager.vala:70: Volume added: %s", _tmp1_);
#line 70 "../src/DiskManager.vala"
	_g_free0 (_tmp1_);
#line 759 "DiskManager.c"
}

static void
__audience_disk_manager___lambda34__g_volume_monitor_volume_added (GVolumeMonitor* _sender,
                                                                   GVolume* volume,
                                                                   gpointer self)
{
#line 68 "../src/DiskManager.vala"
	_audience_disk_manager___lambda34_ ((AudienceDiskManager*) self, volume);
#line 769 "DiskManager.c"
}

static void
_audience_disk_manager___lambda35_ (AudienceDiskManager* self,
                                    GVolume* volume)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 73 "../src/DiskManager.vala"
	g_return_if_fail (volume != NULL);
#line 74 "../src/DiskManager.vala"
	audience_disk_manager_check_for_volume (self, volume);
#line 75 "../src/DiskManager.vala"
	_tmp0_ = g_volume_get_name (volume);
#line 75 "../src/DiskManager.vala"
	_tmp1_ = _tmp0_;
#line 75 "../src/DiskManager.vala"
	g_debug ("DiskManager.vala:75: Volume changed: %s", _tmp1_);
#line 75 "../src/DiskManager.vala"
	_g_free0 (_tmp1_);
#line 790 "DiskManager.c"
}

static void
__audience_disk_manager___lambda35__g_volume_monitor_volume_changed (GVolumeMonitor* _sender,
                                                                     GVolume* volume,
                                                                     gpointer self)
{
#line 73 "../src/DiskManager.vala"
	_audience_disk_manager___lambda35_ ((AudienceDiskManager*) self, volume);
#line 800 "DiskManager.c"
}

static void
_audience_disk_manager___lambda36_ (AudienceDiskManager* self,
                                    GVolume* volume)
{
	GeeTreeSet* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 78 "../src/DiskManager.vala"
	g_return_if_fail (volume != NULL);
#line 79 "../src/DiskManager.vala"
	_tmp0_ = self->priv->volumes;
#line 79 "../src/DiskManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, volume);
#line 80 "../src/DiskManager.vala"
	g_signal_emit (self, audience_disk_manager_signals[AUDIENCE_DISK_MANAGER_VOLUME_REMOVED_SIGNAL], 0, volume);
#line 81 "../src/DiskManager.vala"
	_tmp1_ = g_volume_get_name (volume);
#line 81 "../src/DiskManager.vala"
	_tmp2_ = _tmp1_;
#line 81 "../src/DiskManager.vala"
	g_debug ("DiskManager.vala:81: Volume removed: %s", _tmp2_);
#line 81 "../src/DiskManager.vala"
	_g_free0 (_tmp2_);
#line 826 "DiskManager.c"
}

static void
__audience_disk_manager___lambda36__g_volume_monitor_volume_removed (GVolumeMonitor* _sender,
                                                                     GVolume* volume,
                                                                     gpointer self)
{
#line 78 "../src/DiskManager.vala"
	_audience_disk_manager___lambda36_ ((AudienceDiskManager*) self, volume);
#line 836 "DiskManager.c"
}

static GObject *
audience_disk_manager_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AudienceDiskManager * self;
	GVolumeMonitor* _tmp0_;
	GeeTreeSet* _tmp1_;
	GVolumeMonitor* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	GVolumeMonitor* _tmp5_;
	GVolumeMonitor* _tmp6_;
	GVolumeMonitor* _tmp7_;
	GVolumeMonitor* _tmp8_;
	GVolumeMonitor* _tmp9_;
	GVolumeMonitor* _tmp10_;
	GVolumeMonitor* _tmp11_;
	GVolumeMonitor* _tmp12_;
#line 41 "../src/DiskManager.vala"
	parent_class = G_OBJECT_CLASS (audience_disk_manager_parent_class);
#line 41 "../src/DiskManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 41 "../src/DiskManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AUDIENCE_TYPE_DISK_MANAGER, AudienceDiskManager);
#line 42 "../src/DiskManager.vala"
	_tmp0_ = g_volume_monitor_get ();
#line 42 "../src/DiskManager.vala"
	_g_object_unref0 (self->priv->monitor);
#line 42 "../src/DiskManager.vala"
	self->priv->monitor = _tmp0_;
#line 43 "../src/DiskManager.vala"
	_tmp1_ = gee_tree_set_new (g_volume_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 43 "../src/DiskManager.vala"
	_g_object_unref0 (self->priv->volumes);
#line 43 "../src/DiskManager.vala"
	self->priv->volumes = _tmp1_;
#line 44 "../src/DiskManager.vala"
	_tmp2_ = self->priv->monitor;
#line 44 "../src/DiskManager.vala"
	_tmp3_ = g_volume_monitor_get_volumes (_tmp2_);
#line 44 "../src/DiskManager.vala"
	_tmp4_ = _tmp3_;
#line 44 "../src/DiskManager.vala"
	g_list_foreach (_tmp4_, __audience_disk_manager___lambda28__gfunc, self);
#line 44 "../src/DiskManager.vala"
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (_g_list_free__g_object_unref0_ (_tmp4_), NULL));
#line 48 "../src/DiskManager.vala"
	_tmp5_ = self->priv->monitor;
#line 48 "../src/DiskManager.vala"
	g_signal_connect_object (_tmp5_, "drive-changed", (GCallback) __audience_disk_manager___lambda29__g_volume_monitor_drive_changed, self, 0);
#line 52 "../src/DiskManager.vala"
	_tmp6_ = self->priv->monitor;
#line 52 "../src/DiskManager.vala"
	g_signal_connect_object (_tmp6_, "drive-connected", (GCallback) __audience_disk_manager___lambda30__g_volume_monitor_drive_connected, self, 0);
#line 56 "../src/DiskManager.vala"
	_tmp7_ = self->priv->monitor;
#line 56 "../src/DiskManager.vala"
	g_signal_connect_object (_tmp7_, "drive-disconnected", (GCallback) __audience_disk_manager___lambda31__g_volume_monitor_drive_disconnected, self, 0);
#line 60 "../src/DiskManager.vala"
	_tmp8_ = self->priv->monitor;
#line 60 "../src/DiskManager.vala"
	g_signal_connect_object (_tmp8_, "drive-eject-button", (GCallback) __audience_disk_manager___lambda32__g_volume_monitor_drive_eject_button, self, 0);
#line 64 "../src/DiskManager.vala"
	_tmp9_ = self->priv->monitor;
#line 64 "../src/DiskManager.vala"
	g_signal_connect_object (_tmp9_, "drive-stop-button", (GCallback) __audience_disk_manager___lambda33__g_volume_monitor_drive_stop_button, self, 0);
#line 68 "../src/DiskManager.vala"
	_tmp10_ = self->priv->monitor;
#line 68 "../src/DiskManager.vala"
	g_signal_connect_object (_tmp10_, "volume-added", (GCallback) __audience_disk_manager___lambda34__g_volume_monitor_volume_added, self, 0);
#line 73 "../src/DiskManager.vala"
	_tmp11_ = self->priv->monitor;
#line 73 "../src/DiskManager.vala"
	g_signal_connect_object (_tmp11_, "volume-changed", (GCallback) __audience_disk_manager___lambda35__g_volume_monitor_volume_changed, self, 0);
#line 78 "../src/DiskManager.vala"
	_tmp12_ = self->priv->monitor;
#line 78 "../src/DiskManager.vala"
	g_signal_connect_object (_tmp12_, "volume-removed", (GCallback) __audience_disk_manager___lambda36__g_volume_monitor_volume_removed, self, 0);
#line 41 "../src/DiskManager.vala"
	return obj;
#line 922 "DiskManager.c"
}

static void
audience_disk_manager_class_init (AudienceDiskManagerClass * klass,
                                  gpointer klass_data)
{
#line 21 "../src/DiskManager.vala"
	audience_disk_manager_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/DiskManager.vala"
	g_type_class_adjust_private_offset (klass, &AudienceDiskManager_private_offset);
#line 21 "../src/DiskManager.vala"
	G_OBJECT_CLASS (klass)->constructor = audience_disk_manager_constructor;
#line 21 "../src/DiskManager.vala"
	G_OBJECT_CLASS (klass)->finalize = audience_disk_manager_finalize;
#line 21 "../src/DiskManager.vala"
	audience_disk_manager_signals[AUDIENCE_DISK_MANAGER_VOLUME_FOUND_SIGNAL] = g_signal_new ("volume-found", AUDIENCE_TYPE_DISK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_volume_get_type ());
#line 21 "../src/DiskManager.vala"
	audience_disk_manager_signals[AUDIENCE_DISK_MANAGER_VOLUME_REMOVED_SIGNAL] = g_signal_new ("volume-removed", AUDIENCE_TYPE_DISK_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, g_volume_get_type ());
#line 941 "DiskManager.c"
}

static void
audience_disk_manager_instance_init (AudienceDiskManager * self,
                                     gpointer klass)
{
#line 21 "../src/DiskManager.vala"
	self->priv = audience_disk_manager_get_instance_private (self);
#line 950 "DiskManager.c"
}

static void
audience_disk_manager_finalize (GObject * obj)
{
	AudienceDiskManager * self;
#line 21 "../src/DiskManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AUDIENCE_TYPE_DISK_MANAGER, AudienceDiskManager);
#line 34 "../src/DiskManager.vala"
	_g_object_unref0 (self->priv->monitor);
#line 35 "../src/DiskManager.vala"
	_g_object_unref0 (self->priv->volumes);
#line 21 "../src/DiskManager.vala"
	G_OBJECT_CLASS (audience_disk_manager_parent_class)->finalize (obj);
#line 965 "DiskManager.c"
}

GType
audience_disk_manager_get_type (void)
{
	static volatile gsize audience_disk_manager_type_id__volatile = 0;
	if (g_once_init_enter (&audience_disk_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AudienceDiskManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) audience_disk_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AudienceDiskManager), 0, (GInstanceInitFunc) audience_disk_manager_instance_init, NULL };
		GType audience_disk_manager_type_id;
		audience_disk_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "AudienceDiskManager", &g_define_type_info, 0);
		AudienceDiskManager_private_offset = g_type_add_instance_private (audience_disk_manager_type_id, sizeof (AudienceDiskManagerPrivate));
		g_once_init_leave (&audience_disk_manager_type_id__volatile, audience_disk_manager_type_id);
	}
	return audience_disk_manager_type_id__volatile;
}

